import { AuthTransaction } from './tx';
import { OktaAuth, OktaAuthOptions, SignInWithCredentialsOptions, ForgotPasswordOptions, VerifyRecoveryTokenOptions, TransactionAPI, SessionAPI, SigninAPI, PkceAPI } from './types';
import StorageManager from './StorageManager';
import TransactionManager from './TransactionManager';
export default class OktaAuthBase implements OktaAuth, SigninAPI {
    options: OktaAuthOptions;
    storageManager: StorageManager;
    transactionManager: TransactionManager;
    tx: TransactionAPI;
    userAgent: string;
    session: SessionAPI;
    pkce: PkceAPI;
    constructor(args: OktaAuthOptions);
    signIn(opts: SignInWithCredentialsOptions): Promise<AuthTransaction>;
    getIssuerOrigin(): string;
    forgotPassword(opts: any): Promise<AuthTransaction>;
    unlockAccount(opts: ForgotPasswordOptions): Promise<AuthTransaction>;
    verifyRecoveryToken(opts: VerifyRecoveryTokenOptions): Promise<AuthTransaction>;
}
