import StorageManager from './StorageManager';
import { TransactionMeta, PKCETransactionMeta, OAuthTransactionMeta, TransactionMetaOptions, TransactionManagerOptions } from './types';
export default class TransactionManager {
    options: TransactionManagerOptions;
    storageManager: StorageManager;
    legacyWidgetSupport: boolean;
    saveNonceCookie: boolean;
    saveStateCookie: boolean;
    saveParamsCookie: boolean;
    constructor(options: TransactionManagerOptions);
    clear(options?: TransactionMetaOptions): void;
    save(meta: TransactionMeta, options?: TransactionMetaOptions): void;
    exists(options?: TransactionMetaOptions): boolean;
    load(options?: TransactionMetaOptions): TransactionMeta;
    clearLegacyPKCE(): void;
    loadLegacyPKCE(): PKCETransactionMeta;
    clearLegacyOAuthParams(): void;
    loadLegacyOAuthParams(): OAuthTransactionMeta;
}
